/**
  ******************************************************************************
  * @file    vk1616_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1616_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk1616_driver.h"

/* extern variables ----------------------------------------------------------*/
//extern uint8_t ic_key;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1616_write_buf[16];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/

/*******************************************************************************
* Function Name  : VK1616_delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1616_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : VK1616_delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1616_delay_nms(unsigned long int n)
{
	while(n--)
	{
		VK1616_delay_nus(1000);
	}
}
//GPIO ģI2C 
/*******************************************************************************
* Function Name  : Set_testPara
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1616Write1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	VK1616_STB_LOW;			//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1616_CLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1616_DIO_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1616_DIO_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1616_delay_nus(200);
		VK1616_CLK_HIGH;	//ʱӵ
		VK1616_delay_nus(200);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*******************************************************************************
* Function Name  : VK1616Read1BytefromIC
* Description    : ʱӵͨMCULEDIC1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1616Read1BytefromIC(void)
{
	unsigned char i,k=0;//iѭkʱ

	VK1616_DIO_HIGH;	//ͷDIOΪ
	VK1616_STB_LOW;	//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1616_CLK_LOW;//ȽCLK
		VK1616_delay_nus(200);
		k=k>>1;
		if(VK1616_DIO_IO==0)
		{
			k=k&0x7f;			//DIOΪ͵ƽkλ塰0λֲ
		}
		else
		{
			k=(k|0x80)&0xff;//DIOΪߵƽkλá1λֲ
		}
		VK1616_CLK_HIGH;	//ʱӵ
		VK1616_delay_nus(200);
	}//һֽں˳ѭ
	
	return(k);//ض1ֽ	
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1616_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ
	
	VK1616_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1616Write1BytetoIC(VK1616_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1616_STB_HIGH;//ҪSTBá1
	VK1616Write1BytetoIC(VK1616_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1616Write1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1616_STB_HIGH;//еʾݺ14BYTE󣬽STBá1
	VK1616Write1BytetoIC(VK1616_DISP_ON|VK1616_PDUTY_12_16);//ʾ
	VK1616_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : VK1616_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK1616_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1616_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1616Write1BytetoIC(VK1616_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1616_STB_HIGH;//ҪSTBá1
	VK1616Write1BytetoIC(VK1616_STARTADDR+addr);//ʾݶӦĵַ
	//ַ󣬡STBΪ0Ҫʾ
	VK1616Write1BytetoIC(data8);//֡STB=01BYTEʾ
	VK1616_STB_HIGH;//ʾݺ󽫡STBá1
	VK1616Write1BytetoIC(VK1616_DISP_ON|VK1616_PDUTY_12_16);//ʾ
	VK1616_STB_HIGH;//ʾ󽫡STBá1
}

/*******************************************************************************
* Function Name  : Vk1616_Init
* Description    : 1616ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1616_Init(void)    
{   
	GPIO_SetMode(VK1616_STB_PORT, VK1616_STB_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1616_CLK_PORT, VK1616_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1616_DIO_PORT, VK1616_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1616_STB_HIGH;                
	VK1616_CLK_HIGH;   
	VK1616_DIO_HIGH;
}  

/*******************************************************************************
* Function Name  : VK1616_Main
* Description    : 1616Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1616_Main(void)
{   
	unsigned char i,j;
	
	VK1616_Init();
	 
	for(i=0;i<8;i++)
	{
		vk1616_write_buf[i]=0x00;
	}
	VK1616_Disp_AutoAdd1Addr(0,vk1616_write_buf,8);   //ȫ
	VK1616_delay_nms(1000); 
	while(1)
	{
		for(i=0;i<8;i++)
		{
			vk1616_write_buf[i]=0xff;
		}
		VK1616_Disp_AutoAdd1Addr(0,vk1616_write_buf,8);   //ȫ
		VK1616_delay_nms(1000); 
		for(i=0;i<8;i++)
		{
			vk1616_write_buf[i]=0x00;
		}
		VK1616_Disp_AutoAdd1Addr(0,vk1616_write_buf,8);   //ȫ
		VK1616_delay_nms(1000); 
		
		for(j=0;j<8;j++)
		{
			for(i=0;i<8;i++)
			{
				vk1616_write_buf[i]=0x00;
			}
			vk1616_write_buf[j]=0xff;
			VK1616_Disp_AutoAdd1Addr(0,vk1616_write_buf,8);   //ȫ
			VK1616_delay_nms(500); 
		}
		for(j=0;j<7;j++)
		{
			for(i=0;i<8;i++)
			{
				vk1616_write_buf[i]=(1<<j);
			}
			VK1616_Disp_AutoAdd1Addr(0,vk1616_write_buf,8);   //ȫ
			VK1616_delay_nms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
